// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from autoware_auto_msgs:msg/Complex32.idl
// generated code does not contain a copyright notice

#include "autoware_auto_msgs/msg/detail/complex32__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_autoware_auto_msgs
const rosidl_type_hash_t *
autoware_auto_msgs__msg__Complex32__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x30, 0x49, 0xfc, 0x7f, 0xb1, 0x9f, 0x99, 0xe2,
      0x94, 0xea, 0x74, 0xc8, 0x43, 0xcd, 0x63, 0x30,
      0x62, 0x03, 0xfe, 0x11, 0x0b, 0x87, 0xad, 0xfb,
      0xbd, 0x75, 0x1b, 0x0b, 0x43, 0x16, 0xe9, 0x81,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char autoware_auto_msgs__msg__Complex32__TYPE_NAME[] = "autoware_auto_msgs/msg/Complex32";

// Define type names, field names, and default values
static char autoware_auto_msgs__msg__Complex32__FIELD_NAME__real[] = "real";
static char autoware_auto_msgs__msg__Complex32__DEFAULT_VALUE__real[] = "1.0";
static char autoware_auto_msgs__msg__Complex32__FIELD_NAME__imag[] = "imag";
static char autoware_auto_msgs__msg__Complex32__DEFAULT_VALUE__imag[] = "0.0";

static rosidl_runtime_c__type_description__Field autoware_auto_msgs__msg__Complex32__FIELDS[] = {
  {
    {autoware_auto_msgs__msg__Complex32__FIELD_NAME__real, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {autoware_auto_msgs__msg__Complex32__DEFAULT_VALUE__real, 3, 3},
  },
  {
    {autoware_auto_msgs__msg__Complex32__FIELD_NAME__imag, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {autoware_auto_msgs__msg__Complex32__DEFAULT_VALUE__imag, 3, 3},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
autoware_auto_msgs__msg__Complex32__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {autoware_auto_msgs__msg__Complex32__TYPE_NAME, 32, 32},
      {autoware_auto_msgs__msg__Complex32__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "module autoware_auto_msgs {\n"
  "  module msg {\n"
  "    @verbatim (language=\"comment\", text=\n"
  "      \" Complex32.msg\" \"\\\\n\"\n"
  "      \" Can be used to represent yaw angle for trajectories\" \"\\\\n\"\n"
  "      \" To convert back to a yaw angle, see\" \"\\\\n\"\n"
  "      \" https://en.wikipedia.org/wiki/Conversion_between_quaternions_and_Euler_angles\")\n"
  "    struct Complex32 {\n"
  "      @verbatim (language=\"comment\", text=\n"
  "        \" cos(yaw / 2)\")\n"
  "      @default (value=1.0)\n"
  "      float real;\n"
  "\n"
  "      @verbatim (language=\"comment\", text=\n"
  "        \" sin(yaw / 2)\")\n"
  "      @default (value=0.0)\n"
  "      float imag;\n"
  "    };\n"
  "  };\n"
  "};";

static char idl_encoding[] = "idl";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
autoware_auto_msgs__msg__Complex32__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {autoware_auto_msgs__msg__Complex32__TYPE_NAME, 32, 32},
    {idl_encoding, 3, 3},
    {toplevel_type_raw_source, 581, 581},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
autoware_auto_msgs__msg__Complex32__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *autoware_auto_msgs__msg__Complex32__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
