// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from autoware_auto_msgs:msg/Route.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_auto_msgs/msg/route.hpp"


#ifndef AUTOWARE_AUTO_MSGS__MSG__DETAIL__ROUTE__TRAITS_HPP_
#define AUTOWARE_AUTO_MSGS__MSG__DETAIL__ROUTE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "autoware_auto_msgs/msg/detail/route__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'start_point'
// Member 'goal_point'
#include "autoware_auto_msgs/msg/detail/trajectory_point__traits.hpp"
// Member 'primitives'
#include "autoware_auto_msgs/msg/detail/map_primitive__traits.hpp"

namespace autoware_auto_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Route & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: start_point
  {
    out << "start_point: ";
    to_flow_style_yaml(msg.start_point, out);
    out << ", ";
  }

  // member: goal_point
  {
    out << "goal_point: ";
    to_flow_style_yaml(msg.goal_point, out);
    out << ", ";
  }

  // member: primitives
  {
    if (msg.primitives.size() == 0) {
      out << "primitives: []";
    } else {
      out << "primitives: [";
      size_t pending_items = msg.primitives.size();
      for (auto item : msg.primitives) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Route & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: start_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_point:\n";
    to_block_style_yaml(msg.start_point, out, indentation + 2);
  }

  // member: goal_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_point:\n";
    to_block_style_yaml(msg.goal_point, out, indentation + 2);
  }

  // member: primitives
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.primitives.size() == 0) {
      out << "primitives: []\n";
    } else {
      out << "primitives:\n";
      for (auto item : msg.primitives) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Route & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace autoware_auto_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_auto_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_auto_msgs::msg::Route & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_auto_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_auto_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const autoware_auto_msgs::msg::Route & msg)
{
  return autoware_auto_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_auto_msgs::msg::Route>()
{
  return "autoware_auto_msgs::msg::Route";
}

template<>
inline const char * name<autoware_auto_msgs::msg::Route>()
{
  return "autoware_auto_msgs/msg/Route";
}

template<>
struct has_fixed_size<autoware_auto_msgs::msg::Route>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<autoware_auto_msgs::msg::Route>
  : std::integral_constant<bool, has_bounded_size<autoware_auto_msgs::msg::MapPrimitive>::value && has_bounded_size<autoware_auto_msgs::msg::TrajectoryPoint>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<autoware_auto_msgs::msg::Route>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOWARE_AUTO_MSGS__MSG__DETAIL__ROUTE__TRAITS_HPP_
