// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from autoware_auto_msgs:msg/VehicleStateCommand.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_auto_msgs/msg/vehicle_state_command.hpp"


#ifndef AUTOWARE_AUTO_MSGS__MSG__DETAIL__VEHICLE_STATE_COMMAND__TRAITS_HPP_
#define AUTOWARE_AUTO_MSGS__MSG__DETAIL__VEHICLE_STATE_COMMAND__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "autoware_auto_msgs/msg/detail/vehicle_state_command__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace autoware_auto_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VehicleStateCommand & msg,
  std::ostream & out)
{
  out << "{";
  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: blinker
  {
    out << "blinker: ";
    rosidl_generator_traits::value_to_yaml(msg.blinker, out);
    out << ", ";
  }

  // member: headlight
  {
    out << "headlight: ";
    rosidl_generator_traits::value_to_yaml(msg.headlight, out);
    out << ", ";
  }

  // member: wiper
  {
    out << "wiper: ";
    rosidl_generator_traits::value_to_yaml(msg.wiper, out);
    out << ", ";
  }

  // member: gear
  {
    out << "gear: ";
    rosidl_generator_traits::value_to_yaml(msg.gear, out);
    out << ", ";
  }

  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << ", ";
  }

  // member: hand_brake
  {
    out << "hand_brake: ";
    rosidl_generator_traits::value_to_yaml(msg.hand_brake, out);
    out << ", ";
  }

  // member: horn
  {
    out << "horn: ";
    rosidl_generator_traits::value_to_yaml(msg.horn, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VehicleStateCommand & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: blinker
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blinker: ";
    rosidl_generator_traits::value_to_yaml(msg.blinker, out);
    out << "\n";
  }

  // member: headlight
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "headlight: ";
    rosidl_generator_traits::value_to_yaml(msg.headlight, out);
    out << "\n";
  }

  // member: wiper
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wiper: ";
    rosidl_generator_traits::value_to_yaml(msg.wiper, out);
    out << "\n";
  }

  // member: gear
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gear: ";
    rosidl_generator_traits::value_to_yaml(msg.gear, out);
    out << "\n";
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }

  // member: hand_brake
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hand_brake: ";
    rosidl_generator_traits::value_to_yaml(msg.hand_brake, out);
    out << "\n";
  }

  // member: horn
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "horn: ";
    rosidl_generator_traits::value_to_yaml(msg.horn, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VehicleStateCommand & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace autoware_auto_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_auto_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_auto_msgs::msg::VehicleStateCommand & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_auto_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_auto_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const autoware_auto_msgs::msg::VehicleStateCommand & msg)
{
  return autoware_auto_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_auto_msgs::msg::VehicleStateCommand>()
{
  return "autoware_auto_msgs::msg::VehicleStateCommand";
}

template<>
inline const char * name<autoware_auto_msgs::msg::VehicleStateCommand>()
{
  return "autoware_auto_msgs/msg/VehicleStateCommand";
}

template<>
struct has_fixed_size<autoware_auto_msgs::msg::VehicleStateCommand>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<autoware_auto_msgs::msg::VehicleStateCommand>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<autoware_auto_msgs::msg::VehicleStateCommand>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOWARE_AUTO_MSGS__MSG__DETAIL__VEHICLE_STATE_COMMAND__TRAITS_HPP_
