// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from autoware_auto_msgs:srv/AutonomyModeChange.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_auto_msgs/srv/autonomy_mode_change.h"


#ifndef AUTOWARE_AUTO_MSGS__SRV__DETAIL__AUTONOMY_MODE_CHANGE__STRUCT_H_
#define AUTOWARE_AUTO_MSGS__SRV__DETAIL__AUTONOMY_MODE_CHANGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MODE_MANUAL'.
enum
{
  autoware_auto_msgs__srv__AutonomyModeChange_Request__MODE_MANUAL = 0
};

/// Constant 'MODE_AUTONOMOUS'.
enum
{
  autoware_auto_msgs__srv__AutonomyModeChange_Request__MODE_AUTONOMOUS = 1
};

/// Struct defined in srv/AutonomyModeChange in the package autoware_auto_msgs.
typedef struct autoware_auto_msgs__srv__AutonomyModeChange_Request
{
  /// The desired autonomy mode
  uint8_t mode;
} autoware_auto_msgs__srv__AutonomyModeChange_Request;

// Struct for a sequence of autoware_auto_msgs__srv__AutonomyModeChange_Request.
typedef struct autoware_auto_msgs__srv__AutonomyModeChange_Request__Sequence
{
  autoware_auto_msgs__srv__AutonomyModeChange_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} autoware_auto_msgs__srv__AutonomyModeChange_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'empty'
#include "std_msgs/msg/detail/empty__struct.h"

/// Struct defined in srv/AutonomyModeChange in the package autoware_auto_msgs.
typedef struct autoware_auto_msgs__srv__AutonomyModeChange_Response
{
  /// No response is used because changing the autonomy mode requires non-trivial time
  std_msgs__msg__Empty empty;
} autoware_auto_msgs__srv__AutonomyModeChange_Response;

// Struct for a sequence of autoware_auto_msgs__srv__AutonomyModeChange_Response.
typedef struct autoware_auto_msgs__srv__AutonomyModeChange_Response__Sequence
{
  autoware_auto_msgs__srv__AutonomyModeChange_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} autoware_auto_msgs__srv__AutonomyModeChange_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  autoware_auto_msgs__srv__AutonomyModeChange_Event__request__MAX_SIZE = 1
};
// response
enum
{
  autoware_auto_msgs__srv__AutonomyModeChange_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/AutonomyModeChange in the package autoware_auto_msgs.
typedef struct autoware_auto_msgs__srv__AutonomyModeChange_Event
{
  service_msgs__msg__ServiceEventInfo info;
  autoware_auto_msgs__srv__AutonomyModeChange_Request__Sequence request;
  autoware_auto_msgs__srv__AutonomyModeChange_Response__Sequence response;
} autoware_auto_msgs__srv__AutonomyModeChange_Event;

// Struct for a sequence of autoware_auto_msgs__srv__AutonomyModeChange_Event.
typedef struct autoware_auto_msgs__srv__AutonomyModeChange_Event__Sequence
{
  autoware_auto_msgs__srv__AutonomyModeChange_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} autoware_auto_msgs__srv__AutonomyModeChange_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOWARE_AUTO_MSGS__SRV__DETAIL__AUTONOMY_MODE_CHANGE__STRUCT_H_
