// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from autoware_auto_msgs:msg/RawControlCommand.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_auto_msgs/msg/raw_control_command.hpp"


#ifndef AUTOWARE_AUTO_MSGS__MSG__DETAIL__RAW_CONTROL_COMMAND__STRUCT_HPP_
#define AUTOWARE_AUTO_MSGS__MSG__DETAIL__RAW_CONTROL_COMMAND__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__autoware_auto_msgs__msg__RawControlCommand __attribute__((deprecated))
#else
# define DEPRECATED__autoware_auto_msgs__msg__RawControlCommand __declspec(deprecated)
#endif

namespace autoware_auto_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RawControlCommand_
{
  using Type = RawControlCommand_<ContainerAllocator>;

  explicit RawControlCommand_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->throttle = 0ul;
      this->brake = 0ul;
      this->front_steer = 0l;
      this->rear_steer = 0l;
    }
  }

  explicit RawControlCommand_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->throttle = 0ul;
      this->brake = 0ul;
      this->front_steer = 0l;
      this->rear_steer = 0l;
    }
  }

  // field types and members
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _throttle_type =
    uint32_t;
  _throttle_type throttle;
  using _brake_type =
    uint32_t;
  _brake_type brake;
  using _front_steer_type =
    int32_t;
  _front_steer_type front_steer;
  using _rear_steer_type =
    int32_t;
  _rear_steer_type rear_steer;

  // setters for named parameter idiom
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__throttle(
    const uint32_t & _arg)
  {
    this->throttle = _arg;
    return *this;
  }
  Type & set__brake(
    const uint32_t & _arg)
  {
    this->brake = _arg;
    return *this;
  }
  Type & set__front_steer(
    const int32_t & _arg)
  {
    this->front_steer = _arg;
    return *this;
  }
  Type & set__rear_steer(
    const int32_t & _arg)
  {
    this->rear_steer = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__autoware_auto_msgs__msg__RawControlCommand
    std::shared_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__autoware_auto_msgs__msg__RawControlCommand
    std::shared_ptr<autoware_auto_msgs::msg::RawControlCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RawControlCommand_ & other) const
  {
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->throttle != other.throttle) {
      return false;
    }
    if (this->brake != other.brake) {
      return false;
    }
    if (this->front_steer != other.front_steer) {
      return false;
    }
    if (this->rear_steer != other.rear_steer) {
      return false;
    }
    return true;
  }
  bool operator!=(const RawControlCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RawControlCommand_

// alias to use template instance with default allocator
using RawControlCommand =
  autoware_auto_msgs::msg::RawControlCommand_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace autoware_auto_msgs

#endif  // AUTOWARE_AUTO_MSGS__MSG__DETAIL__RAW_CONTROL_COMMAND__STRUCT_HPP_
